/*
    2݌v} 03

  2002/ 3/ 1 - 2003/ 2/ 3 ˁ@P
*/

#include "windef.h"
#include "classes.h"
#include <stdio.h>

B2String1::B2String1() {

	i32BufferSize=0;
	bfBuffer=NULL;
	s8C_Str=NULL;

	init();

}

B2String1::B2String1(const STR8 s8Arg) {

	i32BufferSize=0;
	bfBuffer=NULL;
	s8C_Str=NULL;

	init();

	assign(s8Arg);

}

B2String1::B2String1(const BUF bfArg,I32 i32Arg) {

	i32BufferSize=0;
	bfBuffer=NULL;
	s8C_Str=NULL;

	init();

	assign(bfArg,i32Arg);

}

B2String1::B2String1(const B2String *pbsArg) {

	i32BufferSize=0;
	bfBuffer=NULL;
	s8C_Str=NULL;

	init();

	assign(pbsArg->getBuffer(),pbsArg->getBufferSize());

}

B2String1::B2String1(const B2String1& bsArg) {

	i32BufferSize=0;
	bfBuffer=NULL;
	s8C_Str=NULL;

	init();

	assign(bsArg.getBuffer(),bsArg.getBufferSize());

}

B2String1 & B2String1::operator=(const B2String1& bsArg) {

	if (&bsArg!=this) {

		init();

		i32MIN_SIZE=bsArg.getMinSize();
		i32MAX_SIZE=bsArg.getMaxSize();

		assign(bsArg.getBuffer(),bsArg.getBufferSize());

	}

	return *this;

}

B2String1 & B2String1::operator=(const STR8 s8Arg) {

	init();

	assign(s8Arg);

	return *this;

}

bool B2String1::operator==(const B2String1& bsArg) const{

	return equal(&bsArg);

}

bool B2String1::operator==(const STR8 s8Arg) const{

	return equal(s8Arg);

}

B2String1 B2String1::operator+(const STR8 s8Arg) {

	B2String1 bsTmp=*this;

	bsTmp.append(s8Arg);

	return bsTmp;

}

B2String1 B2String1::operator+(const B2String1& bsArg) {

	B2String1 bsTmp=*this;

	bsTmp.append(bsArg);

	return bsTmp;

}

B2String1 & B2String1::operator+=(const STR8 s8Arg) {

	append(s8Arg);

	return *this;

}

B2String1 & B2String1::operator+=(const B2String1& bsArg) {

	append(bsArg);

	return *this;

}

void B2String1::init() {

	i32MIN_SIZE=B2String1_MIN_SIZE;
	i32MAX_SIZE=B2String1_MAX_SIZE;

	resizeBuffer(i32MIN_SIZE);
	clear();

}

void B2String1::clear() {

	memset(bfBuffer,0,i32BufferSize);
	i32BufferSize=0;

}

bool B2String1::equal(const BUF bfArg,I32 i32Arg) const{

	if (bfArg==NULL)
		return false;

	if (i32Arg==0)
		return i32BufferSize==0;

	if (i32Arg!=i32BufferSize)
		return false;

	bool bEqual=true;

	for (I32 i=0;i<i32BufferSize;i++)
		if (getByte(i)!=bfArg[i]) {

			bEqual=false;
			break;

		}

	return bEqual;

}

bool B2String1::equal(const STR8 s8Arg) const{

	if (s8Arg==NULL)
		return false;

	I32 i32Len=0;

	while (i32Len<=B2String1_MAX_SIZE && s8Arg[i32Len++]!=0);

	i32Len--;

	return equal((BUF)s8Arg,i32Len);

}

bool B2String1::equal(const B2String *pbsArg) const{

	if (pbsArg==NULL)
		return false;

	return equal(pbsArg->getBuffer(),pbsArg->getBufferSize());

}

bool B2String1::assign(const STR8 s8Arg) {

	if (s8Arg==NULL)
		return false;

	I32 i32Num=0;

	while(i32Num<=i32MAX_SIZE && s8Arg[i32Num++]!=0);

	if (--i32Num==0)
		return false;

	return assign((BUF)s8Arg,i32Num);

}

bool B2String1::assign(const B2String * pbsArg) {

	return assign(pbsArg->getBuffer(),pbsArg->getBufferSize());

}

bool B2String1::assign(const BUF bfArg,I32 i32Arg) {

	if (setBuffer(0,bfArg,i32Arg)) {

		i32BufferSize=i32Arg;
		return true;

	}

	return false;

}

bool B2String1::append(const BYTE byArg) {

	return setBuffer(getLastBufferIndex()+1,(const BUF)(&byArg),1);

}

bool B2String1::append(const BUF bfArg,I32 i32Arg) {

	return setBuffer(getLastBufferIndex()+1,bfArg,i32Arg);

}

bool B2String1::append(const STR8 s8Arg) {

	if (s8Arg==NULL)
		return false;

	I32 i32Num=0;

	while(i32Num<=i32MAX_SIZE && s8Arg[i32Num++]!=0);

	if (--i32Num==0)
		return false;

	return setBuffer(getLastBufferIndex()+1,(BUF)s8Arg,i32Num);

}

bool B2String1::append(const B2String1& bsArg) {

	return setBuffer(getLastBufferIndex()+1,bsArg.getBuffer(),bsArg.getBufferSize());

}

bool B2String1::setBuffer(I32 i32Arg1,const BUF bfArg,I32 i32Arg2) {

	if (bfArg==NULL || i32Arg1<0 || i32Arg1>=i32MAX_SIZE-1 || i32Arg2<1)
		return false;

	I32 i32Num;

	if (i32Arg1+i32Arg2>i32MAX_SIZE)
		i32Num=i32MAX_SIZE-i32Arg1;
	else
		i32Num=i32Arg2;

	if (i32Arg1+i32Num>i32AllocSize && !resizeBuffer(i32Arg1+i32Num))
		return false;

	memcpy(bfBuffer+i32Arg1,bfArg,i32Num);

	i32BufferSize=i32Arg1+i32Num;

	return true;

}

bool B2String1::setByte(I32 i32Index,BYTE bVal) {

	if (i32Index<0 || i32Index>=i32BufferSize)
		return false;

	bfBuffer[i32Index]=bVal;

	return true;

}

const STR8 B2String1::c_str() {

	if (!setC_Str())
		return NULL;

	return s8C_Str;

}

bool B2String1::setC_Str() {

	if (bfBuffer==NULL)
		return false;

	if (s8C_Str!=NULL)
		delete[] s8C_Str;

	I32 i32Size=getStringSize();

	s8C_Str=new CHR8[i32Size+1];

	memcpy(s8C_Str,bfBuffer,i32Size);
	s8C_Str[i32Size]=0;

	return true;

}

bool B2String1::resizeBuffer(I32 i32Arg) {

	if (i32Arg>i32MAX_SIZE || i32Arg<0)
		return false;

	if (i32Arg<i32MIN_SIZE)
		i32Arg=i32MIN_SIZE;

	if (i32BufferSize>0) {

		BUF bfWrk=new BYTE[i32BufferSize];

		memcpy(bfWrk,bfBuffer,i32BufferSize);

		delete[] bfBuffer;
		bfBuffer=new BYTE[i32Arg];
		i32AllocSize=i32Arg;

		if (i32Arg>i32BufferSize)
			memcpy(bfBuffer,bfWrk,i32BufferSize);
		else {

			memcpy(bfBuffer,bfWrk,i32AllocSize);
			i32BufferSize=i32AllocSize;

		}

		delete[] bfWrk;

	} else {

		if (bfBuffer!=NULL)
			delete[] bfBuffer;

		bfBuffer=new BYTE[i32Arg];
		i32AllocSize=i32Arg;

	}

	return true;
}

I32 B2String1::search(BYTE byArg) const {

	I32 i;

	for (i=0;i<i32BufferSize;i++)
		if (bfBuffer[i]==byArg)
			return i;

	return -1;

}

I32 B2String1::search(const BUF bfArg,I32 i32Arg) const {

	if (bfArg==NULL || i32Arg<1 || i32Arg>i32BufferSize)
		return -1;

	I32 i,j;

	for (i=0;i<=i32BufferSize-i32Arg;i++) {

		for (j=0;j<i32Arg;j++)
			if (getByte(i+j)!=bfArg[j])
				break;

		if (j==i32Arg)
			return i;

	}

	return -1;

}

I32 B2String1::search(I32 i32Arg1,const BUF bfArg,I32 i32Arg2) const {

	if (bfArg==NULL || i32Arg1<0 || i32Arg1>=i32BufferSize ||
	    i32Arg2<1 || i32Arg2>i32BufferSize)
		return -1;

	I32 i,j;

	for (i=i32Arg1;i<=i32BufferSize-i32Arg2;i++) {

		for (j=0;j<i32Arg2;j++)
			if (getByte(i+j)!=bfArg[j])
				break;

		if (j==i32Arg2)
			return i;

	}

	return -1;

}

I32 B2String1::search(const STR8 s8Arg) const{

	if (s8Arg==NULL)
		return -1;

	I32 i32Len=0;

	while(i32Len<=i32MAX_SIZE && s8Arg[i32Len++]!=0);

	i32Len--;

	return search((BUF)s8Arg,i32Len);

}

I32 B2String1::searchN(const BUF bfArg,I32 i32Arg) const{

	I32 i32Index=0,i32n=0;

	while((i32Index=search(i32Index,bfArg,i32Arg))>=0) {

		i32n++;
		i32Index+=i32Arg;

	}

	return i32n;

}

I32 B2String1::searchN(const STR8 s8Arg) const{

	if (s8Arg==NULL)
		return 0;

	I32 i32Len=0;

	while(i32Len<=i32MAX_SIZE && s8Arg[i32Len++]!=0);

	i32Len--;

	return searchN((BUF)s8Arg,i32Len);

}

I32 B2String1::rsearch(const BUF bfArg,I32 i32Arg) const {

	if (bfArg==NULL || i32BufferSize<i32Arg)
		return -1;

	for (I32 i=i32BufferSize-i32Arg;i>=0;i--)
		if (search(i,bfArg,i32Arg)==i)
			return i;

	return -1;

}

I32 B2String1::rsearch(const STR8 s8Arg) const{

	if (s8Arg==NULL)
		return -1;

	I32 i32Len=0;

	while(i32Len<=i32MAX_SIZE && s8Arg[i32Len++]!=0);

	i32Len--;

	return rsearch((BUF)s8Arg,i32Len);

}

BYTE B2String1::getByte(I32 i32Arg) const {

	if (i32Arg<0 || i32Arg>=i32BufferSize)
		return 0;

	return bfBuffer[i32Arg];

}

B2Strings * B2String1::split(const STR8 s8Arg) const {

	if (s8Arg==NULL)
		return NULL;

	I32 i32Len=0;

	while(i32Len<=i32MAX_SIZE && s8Arg[i32Len++]!=0);

	if (--i32Len==0)
		return NULL;

	return split((BUF)s8Arg,i32Len);

}

B2Strings * B2String1::split(const BUF bfArg,I32 i32Arg) const {

	if (bfArg==NULL || i32Arg<1 || i32Arg>i32BufferSize)
		return NULL;

	I32 i32Index=0,i32Find;
	B2Strings *bsvReturn=new B2StringVector();

	if (search(i32Index,bfArg,i32Arg)<0) {

		bsvReturn->add(this);

		return bsvReturn;

	}

	while((i32Find=search(i32Index,bfArg,i32Arg))>=0) {

		bsvReturn->add(new B2String1(getBuffer()+i32Index,i32Find-i32Index));
		i32Index=i32Find+i32Arg;

	}

	if (i32Index!=0)
		bsvReturn->add(new B2String1(getBuffer()+i32Index,i32BufferSize-i32Index));

	return bsvReturn;

}

I32 B2String1::replace(const BUF bfArg1,I32 i32Arg1,const BUF bfArg2,I32 i32Arg2) {

	if (bfArg1==NULL || bfArg2==NULL)
		return 0;

	I32 i32N=0,i32Index=0,i32Find;
	B2String1 bsTmp;

	while((i32Find=search(i32Index,bfArg1,i32Arg1))>=0) {

		bsTmp.append(bfBuffer+i32Index,i32Find-i32Index);
		bsTmp.append(bfArg2,i32Arg2);

		i32Index=i32Find+i32Arg1;

		i32N++;

	}

	bsTmp.append(bfBuffer+i32Index,i32BufferSize-i32Index);

	assign(bsTmp.getBuffer(),bsTmp.getBufferSize());

	return i32N;

}

I32 B2String1::replace(const STR8 s8Arg1,const STR8 s8Arg2) {

	if (s8Arg1==NULL || s8Arg2==NULL)
		return NULL;

	I32 i32Len1=0,i32Len2=0;

	while(i32Len1<=i32MAX_SIZE && s8Arg1[i32Len1++]!=0);
	while(i32Len1<=i32MAX_SIZE && s8Arg2[i32Len2++]!=0);

	i32Len1--;
	i32Len2--;

	return replace((BUF)s8Arg1,i32Len1,(BUF)s8Arg2,i32Len2);

}

bool B2String1::del(I32 i32Index) {

	if (i32Index<0 || i32Index>=i32BufferSize)
		return false;

	if (i32Index==0 && i32BufferSize==1) {

		init();

		return true;

	}

	BUF bfTmp=new BYTE[i32BufferSize-1];

	memcpy(bfTmp,bfBuffer,i32Index);

	if (i32Index!=i32BufferSize-1)
		memcpy(bfTmp+i32Index,bfBuffer+i32Index+1,i32BufferSize-i32Index-1);

	assign(bfTmp,i32BufferSize-1);

	delete[] bfTmp;

	return true;

}

bool B2String1::del(I32 i32Index,I32 i32Arg) {

	if (i32Index<0 || i32Index>=i32BufferSize || i32Arg<1 || i32BufferSize<1)
		return false;

	if (i32Index+i32Arg>=i32BufferSize) {

		resizeBuffer(i32Index);

		i32BufferSize=i32Index;

		return true;

	}

	BUF bfTmp=new BYTE[i32BufferSize-i32Arg];

	memcpy(bfTmp,bfBuffer,i32Index);
	memcpy(bfTmp+i32Index,bfBuffer+i32Index+i32Arg,i32BufferSize-(i32Index+i32Arg));

	resizeBuffer(i32BufferSize-i32Arg);
	i32BufferSize-=i32Arg;

	memcpy(bfBuffer,bfTmp,i32BufferSize);

	delete bfTmp;

	return true;

}

I32 B2String1::trim(BYTE bArg) {

	I32 i32N=0;

	while (i32BufferSize>0 && bfBuffer[0]==bArg) {

		del(0);

		i32N++;

	}

	return i32N;

}

bool B2String1::loadFile(const STR8 s8Arg) {

	if (s8Arg==NULL)
		return false;

	FILE *fp=fopen(s8Arg,"rb");

	if (fp==NULL)
		return false;

	fseek(fp,0,SEEK_END);
	I32 i32Len=ftell(fp)+1;
	rewind(fp);

	if (i32Len<1) {

		fclose(fp);
		return false;

	}

	if (i32Len>B2String1_MAX_SIZE)
		i32Len=B2String1_MAX_SIZE;

	BUF bfTmp=new BYTE[i32Len];

	fread(bfTmp,1,i32Len,fp);
	fclose(fp);

	assign(bfTmp,i32Len);

	return true;

}

bool B2String1::saveFile(const STR8 s8Arg) const {
	
	if (s8Arg==NULL)
		return false;

	FILE *fp=fopen(s8Arg,"wb");

	if (fp==NULL)
		return false;

	fwrite(getBuffer(),1,i32BufferSize,fp);
	fclose(fp);

	return true;

}

I32 B2String1::getChr(I32 i32Arg) const { return (I32)getByte(i32Arg); }

I32 B2String1::getBufferSize() const { return i32BufferSize; }

I32 B2String1::getStringSize() const { return i32BufferSize; }

BUF B2String1::getBuffer() const { return bfBuffer; }

I32 B2String1::getClass() const { return CLASS_B2String1; }

I32 B2String1::getEncoding() const { return B2String_ENCODE_NONE; }

I32 B2String1::getLastBufferIndex() const { return i32BufferSize-1; }

I32 B2String1::getMinSize() const { return i32MIN_SIZE; }

I32 B2String1::getMaxSize() const { return i32MAX_SIZE; }

B2String1::~B2String1() {

	if (bfBuffer!=NULL)
		delete bfBuffer;

	if (s8C_Str!=NULL)
		delete s8C_Str;

}
