/*
      2݌v} 03

     2002/ 2/ 3 ˁ@P
*/

#include "windef.h"
#include "classes.h"

B2StringListMap::B2StringListMap() {

	pbmFirst=NULL;
	pbmLast=NULL;

	i32Items=0;

}

B2String * B2StringListMap::getValue(const B2String *pbsArg) const {

	if (i32Items==0 ||pbsArg==NULL ||pbsArg->getStringSize()<1)
		return (B2String *)&bsEmpty;

	B2StringListMapItem *pbmItem=pbmFirst;

	do {

		if (pbmItem->getKey()->equal(pbsArg))
			return pbmItem->getValue();

		pbmItem=pbmItem->getNext();

	} while (pbmItem!=NULL);

	return (B2String *)&bsEmpty;

}

B2String * B2StringListMap::getValue(const STR8 s8Arg) const {

	if (i32Items==0 ||s8Arg==NULL ||s8Arg[0]==0)
		return (B2String *)&bsEmpty;

	B2StringListMapItem *pbmItem=pbmFirst;

	do {

		if (pbmItem->getKey()->equal(s8Arg))
			return pbmItem->getValue();

		pbmItem=pbmItem->getNext();

	} while (pbmItem!=NULL);

	return (B2String *)&bsEmpty;

}

bool B2StringListMap::search(const B2String *bsArg) const {

	if (i32Items==0 ||bsArg==NULL ||bsArg->getStringSize()<1)
		return false;

	B2StringListMapItem *pbmItem=pbmFirst;

	do {

		if (pbmItem->getValue()->equal(bsArg))
			return true;

		pbmItem=pbmItem->getNext();

	} while (pbmItem!=NULL);

	return false;

}

bool B2StringListMap::search(const STR8 s8Arg) const {

	if (i32Items==0 ||s8Arg==NULL ||s8Arg[0]==0)
		return false;

	B2StringListMapItem *pbmItem=pbmFirst;

	do {

		if (pbmItem->getValue()->equal(s8Arg))
			return true;

		pbmItem=pbmItem->getNext();

	} while (pbmItem!=NULL);

	return false;

}

I32 B2StringListMap::getSize() const { return i32Items; }

bool B2StringListMap::add(const B2String *pbsArg1,const B2String *pbsArg2) {

	if (pbsArg1==NULL ||pbsArg1->getStringSize()<1 ||pbsArg2==NULL ||search(pbsArg1))
		return false;

	if (i32Items==0) {

		pbmFirst=new B2StringListMapItem(pbsArg1,pbsArg2,NULL,NULL);
		pbmLast=pbmFirst;
		i32Items=1;

		return true;

	}

	pbmLast=new B2StringListMapItem(pbsArg1,pbsArg2,pbmLast,NULL);
	i32Items++;

	return true;

}

bool B2StringListMap::add(const STR8 s8Arg1,const STR8 s8Arg2) {

	if (s8Arg1==NULL ||s8Arg1[0]==0 ||s8Arg2==NULL ||search(s8Arg1))
		return false;

	if (i32Items==0) {

		pbmFirst=new B2StringListMapItem(s8Arg1,s8Arg2,NULL,NULL);
		pbmLast=pbmFirst;
		i32Items=1;

		return true;

	}

	pbmLast->setNext(new B2StringListMapItem(s8Arg1,s8Arg2,pbmLast,NULL));
	pbmLast=pbmLast->getNext();

	i32Items++;

	return true;

}

bool B2StringListMap::set(const B2String *pbsArg1,const B2String *pbsArg2) {

	if (pbsArg1==NULL ||pbsArg1->getStringSize()<1 ||pbsArg2==NULL)
		return false;

	if (i32Items==0) {

		pbmFirst=new B2StringListMapItem(pbsArg1,pbsArg2,NULL,NULL);
		pbmLast=pbmFirst;
		i32Items=1;

		return true;

	}

	B2StringListMapItem *pbmItem=pbmFirst;

	do {

		if (pbmItem->getKey()->equal(pbsArg1)) {

			pbmItem->setValue(pbsArg2);

			return true;

		}

		pbmItem=pbmItem->getNext();

	} while (pbmItem!=NULL);

	pbmLast=new B2StringListMapItem(pbsArg1,pbsArg2,pbmLast,NULL);
	i32Items++;

	return true;

}

bool B2StringListMap::set(const STR8 s8Arg1,const STR8 s8Arg2) {

	if (s8Arg1==NULL ||s8Arg1[0]==0 ||s8Arg2==NULL)
		return false;

	if (i32Items==0) {

		pbmFirst=new B2StringListMapItem(s8Arg1,s8Arg2,NULL,NULL);
		pbmLast=pbmFirst;
		i32Items=1;

		return true;

	}

	B2StringListMapItem *pbmItem=pbmFirst;

	do {

		if (pbmItem->getKey()->equal(s8Arg1)) {

			pbmItem->setValue(s8Arg2);

			return true;

		}

		pbmItem=pbmItem->getNext();

	} while (pbmItem!=NULL);

	pbmLast=new B2StringListMapItem(s8Arg1,s8Arg2,pbmLast,NULL);
	i32Items++;

	return true;

}

bool B2StringListMap::erase(const B2String *pbsArg) {

	if (pbsArg==NULL ||pbsArg->getStringSize()<1 ||i32Items==0)
		return false;

	B2StringListMapItem *pbmItem=pbmFirst;

	do {

		if (pbmItem->getKey()->equal(pbsArg)) {

			if (i32Items==1) {
				clear();
			} else if (pbmItem==pbmFirst) {
				pbmFirst=pbmItem->getNext();
			} else if (pbmItem==pbmLast) {
				pbmLast=pbmItem->getBack();
			} else {

				(pbmItem->getBack())->setNext(pbmItem->getNext());
				(pbmItem->getNext())->setBack(pbmItem->getBack());

			}

			delete pbmItem;

			return true;

		}

		pbmItem=pbmItem->getNext();

	} while (pbmItem!=NULL);


	return false;

}

bool B2StringListMap::erase(const STR8 s8Arg) {

	if (s8Arg==NULL ||s8Arg[0]==0 ||i32Items==0)
		return false;

	B2StringListMapItem *pbmItem=pbmFirst;

	do {

		if (pbmItem->getKey()->equal(s8Arg)) {

			if (i32Items==1) {
				clear();
			} else if (pbmItem==pbmFirst) {
				pbmFirst=pbmItem->getNext();
			} else if (pbmItem==pbmLast) {
				pbmLast=pbmItem->getBack();
			} else {

				(pbmItem->getBack())->setNext(pbmItem->getNext());
				(pbmItem->getNext())->setBack(pbmItem->getBack());

			}

			delete pbmItem;

			return true;

		}

		pbmItem=pbmItem->getNext();

	} while (pbmItem!=NULL);

	return false;

}

bool B2StringListMap::clear() {

	if (i32Items==0)
		return true;

	B2StringListMapItem *pbmItem=pbmFirst;
	B2StringListMapItem *pbmDel;

	do {

		pbmDel=pbmItem;
		pbmItem=pbmItem->getNext();

		delete pbmDel;

	} while (pbmItem!=NULL);

	return true;

}

B2StringListMapItem * B2StringListMap::getFirstItem() const { return pbmFirst; }
B2StringListMapItem * B2StringListMap::getLastItem() const { return pbmLast; }

B2String * B2StringListMap::operator[](const B2String *pbsArg) {

	return getValue(pbsArg);

}

B2String * B2StringListMap::operator[](const STR8 s8Arg) {

	return getValue(s8Arg);

}

B2StringListMap::~B2StringListMap() { clear(); }
