/*
         2݌v} 03

   2002/ 3/ 1 - 2003/ 2/ 3 ˁ@P
*/

#include "windef.h"
#include "classes.h"

B2StringVector::B2StringVector() {

	i32Strings=0;
	i32Allocated=B2StringVector_MIN;

	ppbsVector=new B2String*[i32Allocated];

}

B2StringVector::B2StringVector(const B2Strings *pbssArg) {

	i32Strings=0;
	i32Allocated=B2StringVector_MIN;

	ppbsVector=new B2String*[i32Allocated];

	assign(pbssArg);

}

B2StringVector::B2StringVector(const B2StringVector& bsvArg) {

	i32Strings=0;
	i32Allocated=B2StringVector_MIN;

	ppbsVector=new B2String*[i32Allocated];

	assign(&bsvArg);

}

bool B2StringVector::assign(const B2Strings *pbssArg) {

	if (pbssArg==NULL)
		return false;

	clear();

	if (!alloc(pbssArg->getSize()))
		return false;

	for (int i=0;i<pbssArg->getSize();i++)
		add(pbssArg->getString(i));
	
	return true;

}

B2StringVector & B2StringVector::operator=(const B2StringVector& bsArg) {

	if (&bsArg!=this)
		assign(&bsArg);

	return *this;

}

B2StringVector B2StringVector::operator+(const STR8 s8Arg) {

	B2StringVector bsvTmp=*this;

	bsvTmp.add(s8Arg);

	return bsvTmp;

}

B2StringVector B2StringVector::operator+(const B2String *pbsArg) {

	B2StringVector bsvTmp=*this;

	bsvTmp.add(pbsArg);

	return bsvTmp;

}

B2StringVector& B2StringVector::operator+=(const STR8 s8Arg) {

	add(s8Arg);

	return *this;

}

B2StringVector& B2StringVector::operator+=(const B2String *pbsArg) {

	add(pbsArg);

	return *this;

}

bool B2StringVector::add(const STR8 s8Arg) {

	if (s8Arg==NULL)
		return false;

	if (!alloc(i32Strings+1))
		return false;

	ppbsVector[i32Strings++]=new B2String_DEFAULT_CLASS(s8Arg);

	return true;

}

bool B2StringVector::add(const B2String *bsArg) {

	I32 i32Class=bsArg->getClass();

	if (!alloc(i32Strings+1))
		return false;

	switch (i32Class) {

	case CLASS_B2String1:

		ppbsVector[i32Strings++]=(B2String *)(new B2String1(bsArg));

		break;

	default:

		return false;

	}

	return true;

}

I32 B2StringVector::add(const B2Strings *pbssArg) {

	if (pbssArg==NULL)
		return 0;

	I32 i;

	for (i=0;i<pbssArg->getSize();i++)
		add(pbssArg->getString(i));

	return i;

}

bool B2StringVector::alloc(I32 i32Arg) {

	if (i32Arg<=i32Allocated)
		return true;

	if (i32Arg>B2StringVector_MAX)
		return false;

	i32Allocated=i32Arg;

	B2String **ppbsTmp=new B2String*[i32Strings];

	I32 i;

	for (i=0;i<i32Strings;i++)
		ppbsTmp[i]=ppbsVector[i];

	delete [] ppbsVector;
	ppbsVector=new B2String*[i32Allocated];

	for (i=0;i<i32Strings;i++)
		ppbsVector[i]=ppbsTmp[i];

	return true;

}

bool B2StringVector::clear() {

	I32 i;

	if (i32Strings==0)
		return true;

	for (i=0;i<i32Strings;i++)
		delete ppbsVector[i];

	delete [] ppbsVector;
	ppbsVector=NULL;

	i32Strings=0;

	i32Allocated=B2StringVector_MIN;

	ppbsVector=new B2String*[i32Allocated];

	return true;

}

B2String * B2StringVector::getString(I32 i32Arg) const {

	if (i32Arg<0 || i32Arg>=i32Strings)
		return NULL;

	return ppbsVector[i32Arg];
}

B2String * B2StringVector::operator[](I32 i32Arg) const {

	return getString(i32Arg);

}

I32 B2StringVector::getSize() const { return i32Strings; }

bool B2StringVector::erase(I32 i32Arg) {
	
	if (i32Arg<0 || i32Arg>=i32Strings)
		return false;

	delete ppbsVector[i32Arg];

	for (I32 i=i32Arg;i<i32Strings-1;i++)
		ppbsVector[i]=ppbsVector[i+1];

	i32Strings--;

	return true;

}

B2StringVector::~B2StringVector() {

	I32 i;

	for (i=0;i<i32Strings;i++)
		delete ppbsVector[i];

	delete [] ppbsVector;

}
